﻿using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace HGrid_Updating.Controllers
{
    public class HomeController : Controller
    {
      public ActionResult Index()
		{
            return View("Index");
        }
        
      public ActionResult HGrid(int selectedValue, List<int> indexToExpand)
		{
       
			GridModel grid = GridLoadOnDemandModel(selectedValue);
			grid.ID = "gridLoadOnDemand";
			grid.LoadOnDemand = true;
			grid.DataSourceUrl = this.Url.Action("BindParent");
			grid.ColumnLayouts[0].DataSourceUrl = this.Url.Action("BindChild");

            var serializer = new JavaScriptSerializer();
            var serializedResult = serializer.Serialize(indexToExpand);

            grid.AddClientEvent("rendered", "gridRendered(" + serializedResult + ");");
          return PartialView("_HGrid", grid);
		}

      private GridModel GridLoadOnDemandModel(int selectedValue)
		{
			// Define the Categories layout
			GridModel grid = new GridModel();
			grid.AutoGenerateLayouts = false;
			grid.AutoGenerateColumns = false;

			

			grid.PrimaryKey = "ID";
			grid.AutoCommit = true;
			grid.Width = "100%";
			grid.Columns.Add(new GridColumn() { HeaderText = "Category ID", Key = "ID", DataType = "number", Width = "20%"});
			grid.Columns.Add(new GridColumn() { HeaderText = "Category Name", Key = "Name", DataType = "string", Width = "30%" });
			grid.Columns.Add(new GridColumn() { HeaderText = "Child ID", Key = "ChildId", DataType = "number", Width = "30%" });
			// Define the Products layout
			GridColumnLayoutModel layout = new GridColumnLayoutModel();
			layout.Key = "Products";
			layout.ForeignKey = "ChildId";
			layout.PrimaryKey = "ID";
			layout.AutoGenerateColumns = false;
			layout.AutoCommit = true;

			layout.Columns.Add(new GridColumn() { HeaderText = "Product ID", Key = "ID", DataType = "number", Width = "20%"});			
			layout.Columns.Add(new GridColumn() { HeaderText = "Product Name", Key = "Name", DataType = "string", Width = "40%" });

            if (selectedValue == 2) {
                // Define the Products layout
                GridColumnLayoutModel layout2 = new GridColumnLayoutModel();
                layout2.Key = "Products";
                layout2.ForeignKey = "ChildId";
                layout2.PrimaryKey = "ID";
                layout2.AutoGenerateColumns = false;
                layout2.AutoCommit = true;

                layout2.Columns.Add(new GridColumn() { HeaderText = "Product ID", Key = "ID", DataType = "number", Width = "20%" });
                layout2.Columns.Add(new GridColumn() { HeaderText = "Product Name", Key = "Name", DataType = "string", Width = "40%" });

                layout2.DataSource = GetProducts();

                grid.ColumnLayouts.Add(layout2);
            }

			GridUpdating updating1 = new GridUpdating();
			layout.Features.Add(updating1);

			layout.Width = "100%";
			grid.ColumnLayouts.Add(layout);

			GridUpdating updating2 = new GridUpdating();
			grid.Features.Add(updating2);

			return grid;
		}


		public JsonResult BindParent()
		{
			GridModel model = GridLoadOnDemandModel(0);
			model.DataSource = GetCategoris().AsQueryable();
			return model.GetData();
		}

		private List<Product> GetProducts()
		{
			List<Product> prods = new List<Product>();
			for (int i = 0; i < 10; i++)
			{
				prods.Add(new Product() { ID= i, Name= "Name"+ i});
			}
			return prods;
		}

		public JsonResult BindChild(string path, string layout)
		{
			JsonResult res = new JsonResult();
			res.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
			int id = Convert.ToInt16(path.Split(':')[1]);
			res.Data = GetProducts().AsQueryable().Where(x => x.ID == id);
			return res;
		}

		private List<Category> GetCategoris()
		{
			List<Category> cats = new List<Category>();
			for (int i = 0; i < 10; i++)
			{
				cats.Add(new Category() { ID = i, Name = "Name" + i, ChildId = i });
			}
			return cats;
		}

    }
}